
function varargout = mlambert(varargin)
% MLAMBERT Application M-file for Pcontour.fig
%    FIG = PContour launch mlambert GUI.
%    MLAMBERT('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 16-Jan-2004 22:35:56

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');
    agiinit;

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

    agiinit;
	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.


% --------------------------------------------------------------------
function varargout = contour_epoch_Callback(h, eventdata, handles, varargin)

% Updates the listbox to match the current workspace

date = get(handles.contour_epoch,'String');

try 
  date2 = datenum(date);
  set(handles.departure_epoch,'String', num2str(date2));
catch
  string = 'Error in date.';  
  set(handles.departure_epoch,'String', string);
end

% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)

date = get(handles.contour_epoch,'String');
axes(handles.contour_axes);


global g_uiApp;
global d_planet a_planet plot_type overlay_type rev transfer_type;
plot_value = get(handles.plot_type_menu,'Value');
overlay_value = get(handles.overlay_type_menu,'Value');
departure_value = get(handles.departure_planet,'Value');
arrival_value = get(handles.arrival_planet,'Value');
transfer_value = get(handles.transfer_type,'Value');
contour_str = get(handles.contour_offset,'String');
contour_offset = str2num(contour_str);
step_str = get(handles.step_counter,'String'); % size of steps in days for counting through arrival and departure times
counter = str2num(step_str);
GRAV = 0.0098066;
Isp =300;


try 
  % test if STK is open.  If not, open it.
  g_stk = g_uiApp.get('Personality2');
catch
    g_uiApp = actxserver('STK7.application');
    
    % get the 'personality2' in order to open files.  This sort of stuff
    % (File I/O, etc) needs to be done in the new STK object model, which
    % requires 'personality2'.  Once open, we make the application visible
    % and load the file.
    g_stk = g_uiApp.get('Personality2');
    
    %make the application visible
    g_uiApp.Visible = 1;
    
    %make the application controlable by the user, so it won't disappear
    %after this script runs.
    g_uiApp.UserControl = 1;

end

% pick transfer type
switch transfer_value
case 1
    transfer_type = 'Types 1,2';
    rev = 0;
case 2
    transfer_type = 'Types 3,4';
    rev = 1;
case 3
    transfer_type = 'Types -3,-4';
    rev = 1;
end

%pick departure planet
switch departure_value
case 1
    d_planet = 'Earth';
case 2
    d_planet = 'Mercury';
case 3
    d_planet = 'Venus';
case 4
    d_planet = 'Mars';
case 5
    d_planet = 'Jupiter';
case 6
    d_planet = 'Saturn';
case 7
    d_planet = 'Uranus';
case 8
    d_planet = 'Nepture';
case 9
    d_planet = 'Pluto';
end

%pick arrival planet
switch arrival_value
case 1
    a_planet = 'Mars';
case 2
    a_planet = 'Mercury';
case 3
    a_planet = 'Venus';
case 4
    a_planet = 'Earth';
case 5
    a_planet = 'Jupiter';
case 6
    a_planet = 'Saturn';
case 7
    a_planet = 'Uranus';
case 8
    a_planet = 'Nepture';
case 9
    a_planet = 'Pluto';
end

%pick plot type
switch plot_value
case 1
    plot_type = 'Departure C3';
case 2
    plot_type = 'Departure Vinf';
case 3
    plot_type = 'Arrival Vinf';
case 4
    plot_type = 'Arrival Dec';
end

%pick plot overlay type
switch overlay_value
case 1
    overlay_type = 'none';
case 2
    overlay_type = 'Departure C3';
case 3
    overlay_type = 'Departure Vinf';
case 4
    overlay_type = 'Arrival Vinf';
case 5
    overlay_type = 'Arrival Dec';
end

tol = 1.e-7;
% mu = atbCbGravParam('Sun')/(1000.0^3);
mu = 1.3271220e+011;

start_date = datenum(date);
start_date_vec = datevec(start_date);

done = 0;

for i = 0:100 

    y(i+1) = contour_offset + i*counter; % start_date + 
    
    set(handles.percent_complete,'String', num2str(i));
    pause(0.001);
            
    for j = 0:100
        % Get position of departure Planet at Departure Date
        DepartDate = datevec(start_date + j*counter); % departure date
        
        atbSetEpoch(DepartDate(1),DepartDate(2),DepartDate(3),DepartDate(4),DepartDate(5),DepartDate(6),'z',0);
        [pos_1, vel_1] = atbCbEphemeris(d_planet, 0); % get position of departure planet
        [pos_0, vel_0] = atbCbEphemeris('Sun', 0); % get position of sun since coordinate system is solar barycenter
        pos_1 = pos_1 - pos_0;
        vel_1 = vel_1 - vel_0;     
        
       % Get position of arrival Planet at Arrival Date 
        ArrivDate = datevec(start_date + j*counter + contour_offset + i*counter); % arrival date 
        atbSetEpoch(ArrivDate(1),ArrivDate(2),ArrivDate(3),ArrivDate(4),ArrivDate(5),ArrivDate(6),'z',0);
        [pos_2, vel_2] = atbCbEphemeris(a_planet, 0); % get position of arrival planet
        [pos_0, vel_0] = atbCbEphemeris('Sun', 0); % get position of sun since coordinate system is solar barycenter
        pos_2 = pos_2 - pos_0;
        vel_2 = vel_2 - vel_0;
        pos_2 = pos_2/1000.0; vel_2 = vel_2/1000.0; % divide by 1000 to get in km, km/sec
        
        % Call the lambert Solver
        time = etime(ArrivDate, DepartDate); % return difference between times in seconds
        theta = 0.0; %not used yet
        pos_1 = pos_1/1000.0; vel_1 = vel_1/1000.0;    % divide by 1000 to get in km, km/sec    
        if (time > 0)
            [dv1, dv2, dv3, dv4, solutions, theta] = lambert(pos_1,vel_1,pos_2,vel_2,time,mu,tol, rev); % call lambert solver
        else
            dv1 = 100;
            dv2 = 100;
            dv3 = 100;
            dv4 = 100;
        end
        matx = atbCbiToCbiMtx(d_planet,a_planet); % rotation Matrix from Earth to Mars
        
        if solutions ~= 2
            save_C3(i+1,j+1) = mag_v(dv1)*mag_v(dv1); 	% save C3 vector at departure
            vinf_out(i+1,j+1) = mag_v(dv1); 	% save vinf vector at departure
            save_vinf(i+1,j+1) = mag_v(dv2); %save vinf dector at arrival
            dv2 = matx*dv2; % rotate into Mars coordinates
            save_a_dec(i+1,j+1) = atan2(dv2(3),sqrt(dv2(1)*dv2(1)+dv2(2)*dv2(2)))/pi*180; %Mars declination
            
        else
            switch transfer_type % if we have multiple solutions, we need to pick which one we want.
            case 'Types -3,-4'
                save_C3(i+1,j+1) = mag_v(dv1)*mag_v(dv1); 	% save C3 vector at departure
                vinf_out(i+1,j+1) = mag_v(dv1); 
                save_vinf(i+1,j+1) = mag_v(dv2);
                dv2 = matx*dv2; % rotate into Mars coordinates
                save_a_dec(i+1,j+1) = atan2(dv2(3),sqrt(dv2(1)*dv2(1)+dv2(2)*dv2(2)))/pi*180; %Mars declination
            case 'Types 3,4'
                save_C3(i+1,j+1) = mag_v(dv3)*mag_v(dv3); 	% save C3 vector at departure
                vinf_out(i+1,j+1) = mag_v(dv3); 
                save_vinf(i+1,j+1) = mag_v(dv4);
                dv4 = matx*dv4'; % rotate into Mars coordinates
                save_a_dec(i+1,j+1) = atan2(dv4(3),sqrt(dv4(1)*dv4(1)+dv4(2)*dv4(2)))/pi*180; % mars declination
            end
        end
        if ~done
            x(j+1) = start_date +j*counter;
        end
    end
    done = 1;
end


switch plot_type
   
case 'Departure C3'
    switch overlay_type 
    case 'Arrival Vinf'
        c = min(min(save_vinf));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 1 2 3 4 5 6 7 8];
        [c,h] = contour(x,y,save_vinf,levels,'--b');
        hold on;
    case 'Arrival Dec'
        levels = -80:2.5:80;
        [c,h] = contour(x,y,save_a_dec,levels,'--b');
        hold on;
    case 'Departure Vinf'
        c = min(min(vinf_out));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 1 2 3 4 5 6 7 8];
        % d+3 d+4 d+6 d+8 d+10 d+12 d+14 d+16 d+18 d+20
        [c,h] = contour(x,y,vinf_out,levels,'--b');
        hold on;
    end
    c = min(min(save_C3));
    c = double(int32(c*10))/10;
    d = double(int32(c))+2;
    levels = [c 2 4 6 8 10 12 14 16];
    % d+3 d+4 d+6 d+8 d+10 d+12 d+14 d+16 d+18 d+20
    [c,h] = contour(x,y,save_C3,levels,'-r');
    clabel(c,h,levels);
    hold off;
case 'Arrival Vinf'
    switch overlay_type 
    case 'Departure C3'
        c = min(min(save_C3));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 2 4 6 8 10 12 14 16];
        % d+3 d+4 d+6 d+8 d+10 d+12 d+14 d+16 d+18 d+20
        [c,h] = contour(x,y,save_C3,levels,'--b');
        hold on;
    case 'Departure Vinf'
        c = min(min(vinf_out));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 1 2 3 4 5 6 7 8];
        %d+3 d+4 d+6 d+8 d+10 d+12 d+14 d+16 d+18 d+20
        [c,h] = contour(x,y,vinf_out,levels,'--b');
        hold on;
    case 'Arrival Dec'
        levels = -80:2.5:80;
        [c,h] = contour(x,y,save_a_dec,levels,'--b');
        hold on;
    end
    c = min(min(save_vinf));
    c = double(int32(c*10))/10;
    d = double(int32(c))+2;
    levels = [c 1 2 3 4 5 6 7 8];
    %d+3 d+4 d+6 d+8 d+10 d+12 d+14 d+16 d+18 d+20
    [c,h] = contour(x,y,save_vinf,levels,'-r');
    clabel(c,h,levels);
    hold off;
case 'Arrival Dec'
    switch overlay_type 
    case 'Departure C3'
        c = min(min(save_C3));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 2 4 6 8 10 12 14 16];
        [c,h] = contour(x,y,save_C3,levels,'--b');
        hold on;
    case 'Departure Vinf'
        c = min(min(vinf_out));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 1 2 3 4 5 6 7 8];
        [c,h] = contour(x,y,vinf_out,levels,'--b');
    case 'Arrival Vinf'
        c = min(min(save_vinf));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 1 2 3 4 5 6 7 8];
        [c,h] = contour(x,y,save_vinf,levels,'--b');
        hold on;
    end
    c = min(min(save_a_dec));
    c = double(int32(c*10))/10;
    d = double(int32(c))+2;
    levels = -80:2.5:80;
    [c,h] = contour(x,y,save_a_dec,levels,'-r');
    clabel(c,h,levels);
    hold off;
case 'Departure Vinf'
    switch overlay_type 
    case 'Arrival Vinf'
        c = min(min(save_vinf));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 1 2 3 4 5 6 7 8];
        [c,h] = contour(x,y,save_vinf,levels,'--b');
        hold on;
    case 'Arrival Dec'
        levels = -80:2.5:80;
        [c,h] = contour(x,y,save_a_dec,levels,'--b');
        hold on;
    case 'Departure C3'
        c = min(min(save_C3));
        c = double(int32(c*10))/10;
        d = double(int32(c))+2;
        levels = [c 2 4 6 8 10 12 14 16];
        [c,h] = contour(x,y,save_C3,levels,'--b');
        hold on;
    end
    c = min(min(vinf_out));
    c = double(int32(c*10))/10;
    d = double(int32(c))+2;
    levels = [c c+.2 c+.4 c+.6 d+2 d+4 d+6];
    [c,h] = contour(x,y,vinf_out,levels,'-r');
    clabel(c,h,levels);
    hold off;
end

datetick('x',12);  
% datetick('y',12); 

xlabel('Launch Date', 'FontSize', 10);
ylabel('Time of Flight (days)', 'FontSize', 10);
title_str = [d_planet ' to ' a_planet ' ' num2str(start_date_vec(1)) ' ' plot_type ' ' transfer_type ];
title(title_str,'FontSize',12);
grid on;

% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)

global Depart_DateNumber Arrival_DateNumber C3 righta dec;

global d_planet a_planet plot_type overlay_type rev transfer_type;

global mars_vhp earth_vhp;

mars_vhp = [0;0;0];
earth_vhp = [0;0;0];
GRAV = 0.0098066;
Isp =300;

% mu = atbCbGravParam('Sun')/(1000.0^3);
mu = 1.3271220e+011;


tol = 1.e-7;

axes(handles.contour_axes);
[Depart_DateNumber,TOF] = ginput(1);

leave = datestr(Depart_DateNumber,0);
arrive = datestr(Depart_DateNumber+TOF,0);

set(handles.departure_epoch,'String', leave);
set(handles.arrival_epoch,'String', arrive);

ArrivDate = datevec(Depart_DateNumber+TOF); % arrival date 
atbSetEpoch(ArrivDate(1),ArrivDate(2),ArrivDate(3),ArrivDate(4),ArrivDate(5),ArrivDate(6),'z',0);
[pos_2, vel_2] = atbCbEphemeris(a_planet, 0); % get position of arrival planet
[pos_0, vel_0] = atbCbEphemeris('Sun', 0); % get position of sun since coordinate system is solar barycenter
pos_2 = pos_2 - pos_0;
vel_2 = vel_2 - vel_0;
pos_2 = pos_2/1000.0; vel_2 = vel_2/1000.0; % divide by 1000 to get in km, km/sec

DepartDate = datevec(Depart_DateNumber); % departure date
atbSetEpoch(DepartDate(1),DepartDate(2),DepartDate(3),DepartDate(4),DepartDate(5),DepartDate(6),'z',0);
[pos_1, vel_1] = atbCbEphemeris(d_planet, 0); % get position of departure planet
[pos_0, vel_0] = atbCbEphemeris('Sun', 0); % get position of sun since coordinate system is solar barycenter
pos_1 = pos_1 - pos_0;
vel_1 = vel_1 - vel_0;     
pos_1 = pos_1/1000.0; vel_1 = vel_1/1000.0;    % divide by 1000 to get in km, km/sec  

% Call the lambert Solver
time = etime(ArrivDate, DepartDate); % return difference between times in seconds
theta = 0.0; %not used yet
[dv1, dv2, dv3, dv4, solutions, theta] = lambert(pos_1,vel_1,pos_2,vel_2,time,mu,tol, rev); % call lambert solver

if solutions ~= 2
    C3 = mag_v(dv1)*mag_v(dv1); 	% save C3 vector at departure
    mars_vhp(1) = dv2(1);
    mars_vhp(2) = dv2(2);
    mars_vhp(3) = dv2(3);
    earth_vhp(1) = dv1(1);
    earth_vhp(2) = dv1(2);
    earth_vhp(3) = dv1(3);
else
    switch transfer_type % if we have multiple solutions, we need to pick which one we want.
    case 'Types -3,-4'
        C3 = mag_v(dv1)*mag_v(dv1); 	% save C3 vector at departure
        mars_vhp(1) = dv2(1);
        mars_vhp(2) = dv2(2);
        mars_vhp(3) = dv2(3);
        earth_vhp(1) = dv1(1);
        earth_vhp(2) = dv1(2);
        earth_vhp(3) = dv1(3);
    case 'Types 3,4'
        C3 = mag_v(dv3)*mag_v(dv3); 	% save C3 vector at departure
        mars_vhp(1) = dv4(1);
        mars_vhp(2) = dv4(2);
        mars_vhp(3) = dv4(3);
        earth_vhp(1) = dv3(1);
        earth_vhp(2) = dv3(2);
        earth_vhp(3) = dv3(3);
    end
end

righta = atan2(earth_vhp(2),earth_vhp(1))/pi*180;
dec = atan2(earth_vhp(3),sqrt(earth_vhp(1)*earth_vhp(1)+earth_vhp(2)*earth_vhp(2)))/pi*180;
vinfa = mag_v(mars_vhp);

matx = atbCbiToCbiMtx(d_planet,a_planet); % rotation Matrix from Earth to Mars

mars_vhp1 = matx*mars_vhp; % rotate into Mars Centered Frame

in_dec = atan2(mars_vhp1(3),sqrt(mars_vhp1(1)*mars_vhp1(1)+mars_vhp1(2)*mars_vhp1(2)))/pi*180; % get incoming declination

indec_str = [num2str(in_dec) ' deg'];
c3_str = [num2str(C3) '  km^2/sec^2'];
righta_str = [num2str(righta) '  deg'];
dec_str = [num2str(dec) '  deg'];
vinf_str = [num2str(vinfa) '  km/sec'];
transfer_str = [num2str(theta/pi*180) '  deg'];

set(handles.arrival_dec,'String', indec_str );
set(handles.C3,'String', c3_str);
set(handles.departure_RA,'String', righta_str);
set(handles.departure_Dec,'String', dec_str);
set(handles.arrival_vinf,'String', vinf_str);
set(handles.transfer_angle,'String', transfer_str);
set(handles.timeofflight,'String', time/86400);

% --------------------------------------------------------------------
function varargout = pushbutton4_Callback(h, eventdata, handles, varargin)

%This function is called by the 'Run STK' button on the GUI page.  It seeds
%the data into the STK scenario from the user's choice on the GUI, and has
%the MCS repropagate.  All the previous commands, based on connect, have
%now been replaced by MS COM calls, using both the STK COM calls, and the
%Astrogator Object model calls.  Last modified, April 15, 2006, Mike
%Loucks, Space Exploration Engineering.  www.see.com

global C3 righta dec;
global g_uiApp;

% Set a few constants to use later.
mu = 1.3271220e+011;
tol = 1.e-7;

% get Dates from GUI
date1 = get(handles.departure_epoch,'String');
date2 = get(handles.arrival_epoch,'String');

% convert dates from standard Date format to Matlab format
Depart_DateNumber = datenum(date1);
Arrival_DateNumber = datenum(date2);

% set name of Satellite
satellite = 'Mars_Sat';

% open MS COM connection to STK
% open Astrogator object model
stkOldInterface=g_uiApp.get('Personality');

% open STK object model
g_stk = g_uiApp.get('Personality2');
scen1 = g_stk.get('CurrentScenario');

% get scenario Epoch and convert to Matlab Date number for later use
Ref_Epoch = scen1.get('Epoch')
STK_DateNumber = datenum(Ref_Epoch);

% Set Departure and Arrival times into Epoch Seconds
Departure_Epoch_Seconds = (Depart_DateNumber - STK_DateNumber)*86400.0;
Arrival_Epoch_Seconds = (Arrival_DateNumber - STK_DateNumber)*86400.0;

% Get pointer to Scenario using Astrogator COM calls, and then get pointer
% to satellite
scenario = stkOldInterface.invoke('Scenario', 0);
satellite_id = scenario.invoke(satellite, 0);

% Pointer to the astrogator MCS
gator=satellite_id.invoke('GetAstrogatorDefn');

% clear all corrections on the internal targeter
mtheTargeter = gator.invoke('GetSegmentByName','Target_Bplane');
notused = mtheTargeter.invoke('reset');

% set initial state segment with epoch from Contour selection
msegment = gator.invoke('GetSegmentByName','Initial_State');
Epoch = msegment.invoke('InitialState.Epoch');
Epoch.invoke('Set',Departure_Epoch_Seconds, 'EpSec');

% set C3 of outgoing asymptote
mC3 = msegment.invoke('InitialState.Target_Vector_Outgoing_Asymptote.C3');
mC3.invoke('Set',C3, 'km^2/sec^2');

% set RA of outgoing asymptote
mrighta = msegment.invoke('InitialState.Target_Vector_Outgoing_Asymptote.AsymRA');
mrighta.invoke('Set',righta, 'deg');

% set Dec of outgoing asymptote
mdec = msegment.invoke('InitialState.Target_Vector_Outgoing_Asymptote.AsymDec');
mdec.invoke('Set',dec, 'deg');

% get Bplane targeter and prepare for setting Desired Arrival Epoch
mtheTargeter = gator.invoke('GetSegmentByName','Target_Bplane');        

desired_profile_name = 'Bplane'; %Note that names with spaces need to have underscores instead
desired_result_name = 'Epoch';
result_segment_name = 'Prop_To_Mars';

% get profile
desired_profile = getprofilebyname(mtheTargeter, desired_profile_name);
    
%extract a pointer to the desired result
Arrival_Epoch = getresultbyname(desired_profile, desired_result_name, result_segment_name);
k_epoch = Arrival_Epoch.invoke('Desired');

% set the Desired arrival epoch
k_epoch.invoke('Set',Arrival_Epoch_Seconds,'EpSec');
        
% Propagate this baby (this command will be changed for 7.1 when we have an
% astrogator runMCS command available.

rtn  = g_stk.ExecuteCommand('Propagate */Satellite/Mars_Sat "18 Apr 2006 00:00:00.00" "1 Nov 2006 00:00:00.00"');

% set a time that is 1 day before arrival and seed that into the animation 
Arrival_Minus_OneDay = Arrival_Epoch_Seconds - 86400;

% seed into scenario with STK object model
g_stk.set('CurrentTime',Arrival_Minus_OneDay)

% --------------------------------------------------------------------
function varargout = calculatepoint_Callback(h, eventdata, handles, varargin)

global Depart_DateNumber Arrival_DateNumber C3 righta dec;

global d_planet a_planet plot_type overlay_type rev transfer_type;

global mars_vhp earth_vhp;

depart = get(handles.departure_epoch,'String');
arrive = get(handles.arrival_epoch,'String');

date1 = datenum(depart);
date2 = datenum(arrive);

mars_vhp = [0;0;0];
earth_vhp = [0;0;0];
GRAV = 0.0098066;
Isp =300;

% mu = atbCbGravParam('Sun')/(1000.0^3);
mu = 1.3271220e+011;
tol = 1.e-7;

Depart_DateNumber = date1;
Arrival_DateNumber = date2;

leave = datestr(Depart_DateNumber,0);
arrive = datestr(Arrival_DateNumber,0);

set(handles.departure_epoch,'String', leave);
set(handles.arrival_epoch,'String', arrive);

ArrivDate = datevec(Arrival_DateNumber); % arrival date 
atbSetEpoch(ArrivDate(1),ArrivDate(2),ArrivDate(3),ArrivDate(4),ArrivDate(5),ArrivDate(6),'z',0);
[pos_2, vel_2] = atbCbEphemeris(a_planet, 0); % get position of arrival planet
[pos_0, vel_0] = atbCbEphemeris('Sun', 0); % get position of sun since coordinate system is solar barycenter
pos_2 = pos_2 - pos_0;
vel_2 = vel_2 - vel_0;
pos_2 = pos_2/1000.0; vel_2 = vel_2/1000.0; % divide by 1000 to get in km, km/sec

DepartDate = datevec(Depart_DateNumber); % departure date
atbSetEpoch(DepartDate(1),DepartDate(2),DepartDate(3),DepartDate(4),DepartDate(5),DepartDate(6),'z',0);
[pos_1, vel_1] = atbCbEphemeris(d_planet, 0); % get position of departure planet
[pos_0, vel_0] = atbCbEphemeris('Sun', 0); % get position of sun since coordinate system is solar barycenter
pos_1 = pos_1 - pos_0;
vel_1 = vel_1 - vel_0;     
pos_1 = pos_1/1000.0; vel_1 = vel_1/1000.0;    % divide by 1000 to get in km, km/sec  

% Call the lambert Solver
time = etime(ArrivDate, DepartDate); % return difference between times in seconds
theta = 0.0; %not used yet
[dv1, dv2, dv3, dv4, solutions, theta] = lambert(pos_1,vel_1,pos_2,vel_2,time,mu,tol, rev); % call lambert solver

if solutions ~= 2
    C3 = mag_v(dv1)*mag_v(dv1); 	% save C3 vector at departure
    mars_vhp(1) = dv2(1);
    mars_vhp(2) = dv2(2);
    mars_vhp(3) = dv2(3);
    earth_vhp(1) = dv1(1);
    earth_vhp(2) = dv1(2);
    earth_vhp(3) = dv1(3);
else
    switch transfer_type % if we have multiple solutions, we need to pick which one we want.
    case 'Types -3,-4'
        C3 = mag_v(dv1)*mag_v(dv1); 	% save C3 vector at departure
        mars_vhp(1) = dv2(1);
        mars_vhp(2) = dv2(2);
        mars_vhp(3) = dv2(3);
        earth_vhp(1) = dv1(1);
        earth_vhp(2) = dv1(2);
        earth_vhp(3) = dv1(3);
    case 'Types 3,4'
        C3 = mag_v(dv3)*mag_v(dv3); 	% save C3 vector at departure
        mars_vhp(1) = dv4(1);
        mars_vhp(2) = dv4(2);
        mars_vhp(3) = dv4(3);
        earth_vhp(1) = dv3(1);
        earth_vhp(2) = dv3(2);
        earth_vhp(3) = dv3(3);
    end
end

righta = atan2(earth_vhp(2),earth_vhp(1))/pi*180;
dec = atan2(earth_vhp(3),sqrt(earth_vhp(1)*earth_vhp(1)+earth_vhp(2)*earth_vhp(2)))/pi*180;
vinfa = mag_v(mars_vhp);

matx = atbCbiToCbiMtx(d_planet,a_planet); % rotation Matrix from Earth to Mars

mars_vhp1 = matx*mars_vhp; % rotate into Mars Centered Frame

in_dec = atan2(mars_vhp1(3),sqrt(mars_vhp1(1)*mars_vhp1(1)+mars_vhp1(2)*mars_vhp1(2)))/pi*180; % get incoming declination

indec_str = [num2str(in_dec) ' deg'];
c3_str = [num2str(C3) '  km^2/sec^2'];
righta_str = [num2str(righta) '  deg'];
dec_str = [num2str(dec) '  deg'];
vinf_str = [num2str(vinfa) '  km/sec'];
transfer_str = [num2str(theta/pi*180) '  deg'];

set(handles.arrival_dec,'String', indec_str );
set(handles.C3,'String', c3_str);
set(handles.departure_RA,'String', righta_str);
set(handles.departure_Dec,'String', dec_str);
set(handles.arrival_vinf,'String', vinf_str);
set(handles.transfer_angle,'String', transfer_str);
set(handles.timeofflight,'String', time/86400);

% --------------------------------------------------------------------
function varargout = departure_epoch_Callback(h, eventdata, handles, varargin)

depart = get(handles.departure_epoch,'String');

try 
  date1 = datenum(depart);
  set(handles.departure_epoch,'String', depart);
catch
  string = 'Error in date.';  
  set(handles.departure_epoch,'String', string);
end



% --------------------------------------------------------------------
function varargout = arrival_epoch_Callback(h, eventdata, handles, varargin)

arrive = get(handles.arrival_epoch,'String');

try 
  date1 = datenum(arrive);
  set(handles.arrival_epoch,'String', arrive);
catch
  string = 'Error in date.';  
  set(handles.arrival_epoch,'String', string);
end

function[save] = getprofilebyname(targeter, profilename)

% function to retrieve a pointer to a profile based on the profile name

    mm = 0;
	while mm < 100     
        try 
            profile_1 = targeter.invoke('profiles',mm);
            k = profile_1.invoke('ComponentName');
            current_profilename = k.invoke('Value');
            if strcmp(current_profilename,profilename)
                save = profile_1;
                mm = 100;
                %disp 'Found Profile Name', profilename, 'Index ', save;
            end
            mm = mm+1;
        catch
            mm = 100;
            disp 'Error finding Profile Name', profilename;
        end    
    end     
    


function[save] = getresultbyname(profile, result_name, ParentSegmentName)

% function to retrieve a pointer to a result based on the result name,
% profile name and segment name
    mm = 0;
	while mm < 100     
        try 
            result = profile.invoke('Results',mm);
            k = result.invoke('ComponentName');
            current_resultname = k.invoke('Value');
            
            k = result.invoke('ParentSegmentName');
            current_ParentSegmentName = k.invoke('Value');
            
            if strcmp(current_resultname,result_name) & strcmp(current_ParentSegmentName,ParentSegmentName)
                save = result;
                mm = 100;
                %disp 'Found Result Name', result_name, 'Index ', save;
            end
            mm = mm+1;
        catch
            mm = 100;
            disp 'Error finding Result Name', result_name;
        end    
    end  

